// Impl&eacute;mentation d'une liste de chaine.<br> Le choix d'impl&eacute;mentaition et les m&eacute;thodes sont &agrave; l'image de ArrayList.

/**
   Exercice de creation d'une classe qui g&egrave;re une collection de chaine de caract&egrave;re.<br>
   L'objectif est d'encapsuler l'impl&eacute;mentation de cette classe en cr&eacute;ant des m&eacute;thodes d'utilisation de la collection (comme ArrayList mais a minima).<br>
   Le choix d'impl&eacute;mentation de la classe est celui d'un tableau Java de String.
*/
public class Exercice15
{
    /**
       Methode main de test de la classe ListeString.
       @param args non utilis&eacute;
    */
    public static void main(String args[]) 
    {
        // Pour finir le programme
        boolean fini = false;

        // Creation de la liste
        ListeString liste = new ListeString(); 
        
        // Activation des traces de la classe
        ListeString.trace = true; 

        // Traitement qui affiche un menu pour chacun des cas de test
        //
        while (!fini){

            // Le mnenu est affiche
            Terminal.ecrireStringln("-----------------");
            Terminal.ecrireStringln("1 : void add(String s)");
            Terminal.ecrireStringln("2 : int size()");
            Terminal.ecrireStringln("3 : String get(int indice)");
            Terminal.ecrireStringln("4 : void set(int indice, String valeur)");
            Terminal.ecrireStringln("5 : int indexOf(String occurrence)");
            Terminal.ecrireStringln("6 : indexOf(int debut, String occurrence)");
            Terminal.ecrireStringln("7 : boolean remove(int indice)");
            Terminal.ecrireStringln("8 : initialisation de la liste");
            Terminal.ecrireStringln("0 : exit");
            Terminal.ecrireStringln("-----------------");
            afficherLaListe(liste);
            Terminal.ecrireStringln("-----------------");

            // Saisir le choix
            Terminal.ecrireString("Choix: ");
            int choix = Terminal.lireInt();
            
            // Les cas de test
            switch(choix)
                {
                case 0 : 
                    {
                        // Sortir du programme
                        fini=true;
                        break;
                    }

                case 1:
                    {
                        // Ajout d'un element
                        Terminal.ecrireString("s = ");
                        String s = Terminal.lireString();
                        liste.add(s);
                        break;
                    }
                case 2:
                    {
                        // Taille de la liste
                        int taille = liste.size();
                        Terminal.ecrireStringln("Taille = "+taille);
                        break;
                    }
                case 3:
                    {
                        // Acces a un element de la liste
                        Terminal.ecrireString("indice = ");
                        int indice = Terminal.lireInt();
                        //
                        String valeur = liste.get(indice);
                        if (valeur!=null) Terminal.ecrireStringln("get = "+valeur);
                        else Terminal.ecrireStringln("Incorrect");
                        break;
                    }

                case 4:
                    {
                        // Changer un element de la liste
                        Terminal.ecrireString("indice = ");
                        int indice = Terminal.lireInt();
                        Terminal.ecrireString("valeur = ");
                        String valeur = Terminal.lireString();
                        //
                        boolean res = liste.set(indice,valeur);
                        if (res) Terminal.ecrireStringln("Correct");
                        else Terminal.ecrireStringln("Incorrect");
                        break;
                    }
                case 5:
                    {
                        // Rechercher un element a partir d'un indice
                        Terminal.ecrireString("valeur = ");
                        String valeur = Terminal.lireString();
                        //
                        int index = liste.indexOf(valeur);
                        Terminal.ecrireStringln("index = "+index);
                        break;
                    }
                case 6:
                    {
                        // Rechercher un element a partir d'un indice
                        Terminal.ecrireString("debut = ");
                        int debut = Terminal.lireInt();

                        Terminal.ecrireString("valeur = ");
                        String valeur = Terminal.lireString();
                        //
                        int index = liste.indexOf(debut,valeur);
                        Terminal.ecrireStringln("index = "+index);
                        break;
                    }
                case 7:
                    {
                        // Suppression d'un element
                        Terminal.ecrireString("indice = ");
                        int indice = Terminal.lireInt();
                        //
                        boolean res = liste.remove(indice);
                        if (res) Terminal.ecrireStringln("Correct");
                        else Terminal.ecrireStringln("Incorrect");
                        break;
                    }
                case 8:
                    {
                        // Initialisation de la liste avec des valeurs fixes
                        //  (afin d'alleger le travail du testeur)
                        //
                        liste = new ListeString();
                        liste.add("Zoe");
                        liste.add("Lafont");
                        liste.add("Dupont");
                        liste.add("Flament");
                        liste.add("Durand");
                        break;
                    }
                }
        }

    }

    /** Methode interne qui affiche le contenu de la liste 
        @param l la liste &agrave; afficher
    */
    static void afficherLaListe(ListeString l)
    {
        Terminal.ecrireStringln("La liste:");
        if (l==null) return;
        for(int i=0;i<l.size();i++)
            Terminal.ecrireStringln(i + ":" + l.get(i));
    }
}